#include <iostream>

using namespace std;

int D[10000][4];
int AB[10000];
int ABi[10000];

int main()
{

    int n;
    int o;
    int a;
    int b;
    int ab;
    int i;

    int brojac = 0;

    scanf("%i",&n);
    scanf("%i",&o);
    scanf("%i",&a);
    scanf("%i",&b);
    scanf("%i",&ab);

    for(i = 0; i < n; i++){

        string s;
        int broj;
        cin >> s;
        cin >> broj;
        D[i][0] = 0;
        D[i][1] = 0;
        D[i][2] = 0;
        D[i][3] = 0;

        if(s == "O"){
            if(broj <= o){
            D[i][0] = broj;
            o -= broj;
           }
            else{
                printf("nemoguce\n");
                return 0;
            }
        }

        if(s == "A"){
            if(broj <= a){
                D[i][1] = broj;
                a -= broj;
            }

            else if(broj > a){
                broj -= a;

                if(broj <= o){
                    D[i][1] = a;
                    D[i][0] = broj;
                    o -= broj;
                    a = 0;
                }
                else{
                    printf("nemoguce\n");
                    return 0;
                }
            }
        }

        if(s == "B"){
            if(broj <= b){
                D[i][2] = broj;
                b -= broj;
            }
                else if(broj > b){
                    broj -= b;

                    if(broj <= o){
                        D[i][0] = broj;
                        D[i][2] = b;
                        o -= broj;
                        b = 0;
                    }

                    else{
                        printf("nemoguce\n");
                        return 0;
                    }
                }
        }

        if(s == "AB"){
            if(broj <= ab){
                D[i][3] = broj;
                ab -= broj;
            }

            else{
                AB[brojac] = broj;
                ABi[brojac] = i;
                brojac++;
            }
        }

    }

    for(i = 0; i < brojac; i++){
        D[ABi[i]][3] = ab;
        AB[i] -= ab;
        ab = 0;

        if(AB[i]  <= o){
            D[ABi[i]][0] = AB[i];
            o -= AB[i];
        }

        else if(AB[i]  > o){
            D[ABi[i]][0] = o;
            AB[i]  -= o;
            o = 0;

            if(AB[i]  <= a){
                D[ABi[i]][1] = AB[i] ;
                a -= AB[i] ;
            }
            else if(AB[i]  > a){
                D[ABi[i]][1] = a;
                AB[i] -= a;
                a = 0;

                if(AB[i]  <= b){
                    D[ABi[i]][2] = AB[i] ;
                    b-= AB[i];
                }
                else if(AB[i]  > b){
                    printf("nemoguce\n");
                    return 0;
                }
            }
        }
    }

    printf("moguce\n");
    for(i = 0; i < n; i++){
        for(int j = 0; j < 4; j++){
            printf("%i ", D[i][j]);
        }
        printf("\n");
    }

    return 0;
}